# ImageTransformations

[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

This package provides support for image resizing, image rotation, and
other spatial transformations of arrays.

<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageTransformations.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageTransformations.jl/workflows/Unit%20test/badge.svg
[action-url]: https://github.com/JuliaImages/ImageTransformations.jl/actions
[codecov-img]: https://codecov.io/github/JuliaImages/ImageTransformations.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageTransformations.jl?branch=master
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaImages.github.io/ImageTransformations.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaImages.github.io/ImageTransformations.jl/dev

"""
    warp(img, tform, [indices]; kwargs...) -> imgw

Transform the coordinates of `img`, returning a new `imgw` satisfying `imgw[I] = img[tform(I)]`.

# Output

The output array `imgw` is an `OffsetArray`. Unless manually specified, `axes(imgw) == axes(img)`
does not hold in general. If you just want a plain array, you can "strip" the custom indices with
`parent(imgw)` or `OffsetArrays.no_offset_view(imgw)`.

# Arguments

- `img`: the original image that you need coordinate transformation.
- `tform`: the coordinate transformation function or function-like object, it must accept a
  [`SVector`](https://github.com/JuliaArrays/StaticArrays.jl) as input. A useful package to
  create a wide variety of such transformations is
  [CoordinateTransformations.jl](https://github.com/FugroRoames/CoordinateTransformations.jl).
- `indices` (Optional): specifies the output image axes.
  By default, the indices are computed in such a way that `imgw` contains all the original pixels
  in `img` using [`autorange`](@ref ImageTransformations.autorange). To do this `inv(tform)` has
  to be computed. If the given transformation `tform` does not support `inv` then the parameter
  `indices` has to be specified manually.

# Parameters

!!! info
    To construct `method` and `fillvalue` values, you may need to load `Interpolations` package first.

- `method::Union{Degree, InterpolationType}`: the interpolation method you want to use. By default it is
  `BSpline(Linear())`. To construct the method instance, one may need to load `Interpolations`.
- `fillvalue`: the value that used to fill the new region. The default value is `NaN` if possible,
  otherwise is `0`. One can also pass the extrapolation boundary condition: `Flat()`, `Reflect()` and `Periodic()`.

# See also

There're some high-level interfaces of `warp`:

- image rotation: [`imrotate`](@ref)
- image resize: [`imresize`](@ref)

There are also lazy versions of `warp`:

- [`WarpedView`](@ref) is almost equivalent to `warp` except that it does not allocate memory.
- [`InvWarpedView(img, tform, [indices]; kwargs...)`](@ref ImageTransformations.InvWarpedView)
  is almost equivalent to `warp(img, inv(tform), [indices]; kwargs...)` except that it does not
  allocate memory.

# Extended help

## Parameters in detail

This approach is known as backward mode warping. It is called "backward" because
the internal coordinate transformation is actually an inverse map from `axes(imgr)` to `axes(img)`.

You can manually specify interpolation behavior by constructing `AbstractExtrapolation` object
and passing it to `warp` as `img`. However, this is usually cumbersome. For this reason, there
are two keywords `method` and `fillvalue` to conveniently construct an `AbstractExtrapolation`
object during `warp`.

!!! warning
    If `img` is an `AbstractExtrapolation`, then additional `method` and `fillvalue` keywords
    will be discarded.

### `method::Union{Degree, InterpolationType}`

The interpolation method you want to use to reconstruct values in the wrapped image.

Among those possible `InterpolationType` choice, there are some commonly used methods that you may
have used in other languages:

- nearest neighbor: `BSpline(Constant())`
- triangle/bilinear: `BSpline(Linear())`
- bicubic: `BSpline(Cubic(Line(OnGrid())))`
- lanczos2: `Lanczos(2)`
- lanczos3: `Lanczos(3)`
- lanczos4: `Lanczos(4)` or `Lanczos4OpenCV()`

When passing a `Degree`, it is expected to be a `BSpline`. For example, `Linear()` is equivalent to
`BSpline(Linear())`.

### `fillvalue`

In case `tform(I)` maps to indices outside the original `img`, those locations are set to a value
`fillvalue`. The default fillvalue is `NaN` if the element type of `img` supports it, and `0`
otherwise.

The parameter `fillvalue` can be either a `Number` or `Colorant`. In this case, it will be
converted to `eltype(imgr)` first. For example, `fillvalue = 1` will be converted to `Gray(1)` which
will fill the outside indices with white pixels.

Also, `fillvalue` can be extrapolation schemes: `Flat()`, `Periodic()` and `Reflect()`. The best
way to understand these schemes is perhaps try it with small example:

```jldoctest
julia> using ImageTransformations, TestImages, Interpolations

julia> using OffsetArrays: IdOffsetRange

julia> img = testimage("lighthouse");

julia> imgr = imrotate(img, π/4; fillvalue=Flat()); # zero extrapolation slope

julia> imgr = imrotate(img, π/4; fillvalue=Periodic()); # periodic boundary

julia> imgr = imrotate(img, π/4; fillvalue=Reflect()); # mirror boundary

julia> axes(imgr)
(IdOffsetRange(values=-196:709, indices=-196:709), IdOffsetRange(values=-68:837, indices=-68:837))
```

## The meaning of the coordinates

`imgw` keeps track of the indices that would result from applying `inv(tform)` to the indices of
`img`. This can be very handy for keeping track of how pixels in `imgw` line up with
pixels in `img`.

```jldoctest
julia> using ImageTransformations, TestImages, Interpolations

julia> img = testimage("lighthouse");

julia> imgr = imrotate(img, π/4);

julia> imgr_cropped = imrotate(img, π/4, axes(img));

julia> imgr[axes(img)...] == imgr_cropped # No need to manually calculate the offsets
true
```

!!! tip
    For performance consideration, it's recommended to pass the `inds` positional argument to
    `warp` instead of cropping the output with `imgw[inds...]`.

# Examples: a 2d rotation

!!! note
    This example only shows how to construct `tform` and calls `warp`. For common usage, it is
    recommended to use [`imrotate`](@ref) function directly.

Rotate around the center of `img`:

```jldoctest
julia> using ImageTransformations, CoordinateTransformations, Rotations, TestImages, OffsetArrays

julia> using OffsetArrays: IdOffsetRange

julia> img = testimage("lighthouse");

julia> axes(img)
(Base.OneTo(512), Base.OneTo(768))

julia> tfm = recenter(RotMatrix(-pi/4), center(img));

julia> imgw = warp(img, tfm);

julia> axes(imgw)
(IdOffsetRange(values=-196:709, indices=-196:709), IdOffsetRange(values=-68:837, indices=-68:837))
```

"""
function warp(img::AbstractExtrapolation{T}, tform, inds::Tuple = autorange(img, inv(tform))) where T
    out = similar(Array{T}, inds)
    warp!(out, img, try_static(tform, img))
end

function warp!(out, img::AbstractExtrapolation, tform)
    @inbounds for I in CartesianIndices(axes(out))
        # Backward mode:
        #   1. get the target index `I` of `out`
        #   2. maps _back_ to original index `Ĩ` of `img`
        #   3. interpolate/extrapolate the value of `Ĩ`
        #   4. this value is then assigned to `out[I]`
        # The advantage of backward mode is that all piexels
        # in the output image will be iterated once very efficiently.
        out[I] = _getindex(img, tform(SVector(I.I)))
    end
    out
end

function warp(img::AbstractArray, tform, args...; kwargs...)
    etp = box_extrapolation(img; kwargs...)
    warp(etp, try_static(tform, img), args...)
end

"""
    imrotate(img, θ, [indices]; kwargs...) -> imgr

Rotate image `img` by `θ`∈[0,2π) in a clockwise direction around its center point.

# Arguments

- `img::AbstractArray`: the original image that you need to rotate.
- `θ::Real`: the rotation angle in clockwise direction.
  To rotate the image in conter-clockwise direction, use a negative value instead.
  To rotate the image by `d` degree, use the formular `θ=d*π/180`.
- `indices` (Optional): specifies the output image axes. By default, rotated image `imgr` will not be
  cropped, and thus `axes(imgr) == axes(img)` does not hold in general.

# Parameters

!!! info
    To construct `method` and `fillvalue` values, you may need to load `Interpolations` package first.

- `method::Union{Degree, InterpolationType}`: the interpolation method you want to use. By default it is
  `Linear()`.
- `fillvalue`: the value that used to fill the new region. The default value is `NaN` if possible,
  otherwise is `0`.

This function is a simple high-level interface to `warp`, for more explaination and details,
please refer to [`warp`](@ref).

# Examples

```julia
using TestImages, ImageTransformations
img = testimage("cameraman")

# Rotate the image by π/4 in the clockwise direction
imgr = imrotate(img, π/4) # output axes (-105:618, -105:618)

# Rotate the image by π/4 in the counter-clockwise direction
imgr = imrotate(img, -π/4) # output axes (-105:618, -105:618)

# Preserve the original axes
# Note that this is more efficient than `@view imrotate(img, π/4)[axes(img)...]`
imgr = imrotate(img, π/4, axes(img)) # output axes (1:512, 1:512)
```

By default, `imrotate` uses bilinear interpolation with constant fill value (`NaN` or `0`). You can,
for example, use the nearest interpolation and fill the new region with white pixels:

```julia
using Interpolations, ImageCore
imrotate(img, π/4, method=Constant(), fillvalue=oneunit(eltype(img)))
```

And with some inspiration, maybe fill with periodic values and tile the output together to
get a mosaic:

```julia
using Interpolations, ImageCore
imgr = imrotate(img, π/4, fillvalue = Periodic())
mosaicview([imgr for _ in 1:9]; nrow=3)
```
"""
function imrotate(img::AbstractArray{T}, θ::Real, inds::Union{Tuple, Nothing} = nothing; kwargs...) where T
    # TODO: expose rotation center as a keyword
    tform = recenter(rotmtrx2(θ), center(img))
    # Use the `nothing` trick here because moving the `autorange` as default value is not type-stable
    inds = isnothing(inds) ? autorange(img, inv(tform)) : inds
    warp(img, tform, inds; kwargs...)
end
_mod2pi(θ) = mod2pi(θ)
_mod2pi(θ::Irrational{:π}) = θ
_mod2pi(θ::Irrational) = mod2pi(float(θ))

function rotmtrx2(θ::T) where T<:Real
    Δ = eps(float(θ))
    θ = _mod2pi(θ)
    FT = floattype(T)
    if abs(θ) <= Δ || abs(θ - 2π) <= Δ
        return RotMatrix{2,FT}(@SMatrix [1 0; 0 1])
    elseif abs(θ - π) <= Δ
        return RotMatrix{2,FT}(@SMatrix [-1 0; 0 -1])
    else
        return RotMatrix{2,FT}(θ)
    end
end
rotmtrx2(θ::Irrational{:π}) = RotMatrix(@SMatrix [-1 0; 0 -1])

@testset "_default_fillvalue" begin
    @test_throws UndefVarError _default_fillvalue
    @test typeof(ImageTransformations._default_fillvalue) <: Function

    @test @inferred(ImageTransformations._default_fillvalue(N0f8)) === N0f8(0)
    @test @inferred(ImageTransformations._default_fillvalue(Int)) === 0
    @test @inferred(ImageTransformations._default_fillvalue(Float16)) === NaN16
    @test @inferred(ImageTransformations._default_fillvalue(Float32)) === NaN32
    @test @inferred(ImageTransformations._default_fillvalue(Float64)) === NaN

    @test @inferred(ImageTransformations._default_fillvalue(Gray{N0f8})) === Gray{N0f8}(0)
    @test @inferred(ImageTransformations._default_fillvalue(Gray{Float16})) === Gray{Float16}(NaN16)
    @test @inferred(ImageTransformations._default_fillvalue(Gray{Float32})) === Gray{Float32}(NaN32)
    @test @inferred(ImageTransformations._default_fillvalue(Gray{Float64})) === Gray{Float64}(NaN)

    @test @inferred(ImageTransformations._default_fillvalue(GrayA{N0f8})) === GrayA{N0f8}(0,0)
    @test @inferred(ImageTransformations._default_fillvalue(GrayA{Float16})) === GrayA{Float16}(NaN16,NaN16)
    @test @inferred(ImageTransformations._default_fillvalue(GrayA{Float32})) === GrayA{Float32}(NaN32,NaN32)
    @test @inferred(ImageTransformations._default_fillvalue(GrayA{Float64})) === GrayA{Float64}(NaN,NaN)

    @test @inferred(ImageTransformations._default_fillvalue(RGB{N0f8})) === RGB{N0f8}(0,0,0)
    @test @inferred(ImageTransformations._default_fillvalue(RGB{Float16})) === RGB{Float16}(NaN16,NaN16,NaN16)
    @test @inferred(ImageTransformations._default_fillvalue(RGB{Float32})) === RGB{Float32}(NaN32,NaN32,NaN32)
    @test @inferred(ImageTransformations._default_fillvalue(RGB{Float64})) === RGB{Float64}(NaN,NaN,NaN)

    @test @inferred(ImageTransformations._default_fillvalue(RGBA{N0f8})) === RGBA{N0f8}(0,0,0,0)
    @test @inferred(ImageTransformations._default_fillvalue(RGBA{Float16})) === RGBA{Float16}(NaN16,NaN16,NaN16,NaN16)
    @test @inferred(ImageTransformations._default_fillvalue(RGBA{Float32})) === RGBA{Float32}(NaN32,NaN32,NaN32,NaN32)
    @test @inferred(ImageTransformations._default_fillvalue(RGBA{Float64})) === RGBA{Float64}(NaN,NaN,NaN,NaN)

    @test @inferred(ImageTransformations._default_fillvalue(HSV{Float16})) === HSV{Float16}(NaN16,NaN16,NaN16)
    @test @inferred(ImageTransformations._default_fillvalue(HSV{Float32})) === HSV{Float32}(NaN32,NaN32,NaN32)
    @test @inferred(ImageTransformations._default_fillvalue(HSV{Float64})) === HSV{Float64}(NaN,NaN,NaN)
end

@testset "box_extrapolation" begin
    @test_throws UndefVarError box_extrapolation
    @test typeof(ImageTransformations.box_extrapolation) <: Function

    img = rand(Gray{N0f8}, 2, 2)

    for method in (Linear(), BSpline(Linear()), Constant(), BSpline(Constant()))
        etp = @inferred ImageTransformations.box_extrapolation(img, method=method)
        @test @inferred(ImageTransformations.box_extrapolation(etp)) === etp
        @test_nowarn summary(etp)
        @test size(etp) == size(img)
        @test eltype(etp) == eltype(img)
        @test etp.itp isa Interpolations.BSplineInterpolation
        @test etp isa Interpolations.FilledExtrapolation
        @test etp.fillvalue === Gray{N0f8}(0.0)
        @test etp.itp.coefs === img
    end

    # to catch regressions like #60
    @test @inferred(ImageTransformations._getindex(img, @SVector([1,2]))) isa Gray{N0f8}

    etp = @inferred ImageTransformations.box_extrapolation(img)
    etp2 = @inferred ImageTransformations.box_extrapolation(etp.itp)
    @test_nowarn summary(etp2)
    @test size(etp2) == size(img)
    @test eltype(etp2) == eltype(img)
    @test etp2.itp isa Interpolations.BSplineInterpolation
    @test etp2 isa Interpolations.FilledExtrapolation
    @test etp2.fillvalue === Gray{N0f8}(0.0)
    @test etp2.itp === etp.itp

    etp = @inferred ImageTransformations.box_extrapolation(img)
    etp2 = @inferred ImageTransformations.box_extrapolation(etp.itp, fillvalue=Flat())
    @test_nowarn summary(etp2)
    @test size(etp2) == size(img)
    @test eltype(etp2) == eltype(img)
    @test etp2.itp isa Interpolations.BSplineInterpolation
    @test etp2 isa Interpolations.Extrapolation
    @test etp2.et == Flat()
    @test etp2 !== etp
    @test etp2.itp === etp.itp

    etp = @inferred ImageTransformations.box_extrapolation(img, fillvalue=1)
    @test_nowarn summary(etp)
    @test size(etp) == size(img)
    @test eltype(etp) == eltype(img)
    @test etp.itp isa Interpolations.BSplineInterpolation
    @test etp isa Interpolations.FilledExtrapolation
    @test etp.fillvalue === Gray{N0f8}(1.0)
    @test etp.itp.coefs === img

    etp = @inferred ImageTransformations.box_extrapolation(img, fillvalue=Flat())
    @test @inferred(ImageTransformations.box_extrapolation(etp)) === etp
    @test_nowarn summary(etp)
    @test size(etp) == size(img)
    @test eltype(etp) == eltype(img)
    @test etp.itp isa Interpolations.BSplineInterpolation
    @test etp isa Interpolations.Extrapolation
    @test etp.et == Flat()
    @test etp.itp.coefs === img

    etp = @inferred ImageTransformations.box_extrapolation(img, method=Constant())
    @test_nowarn summary(etp)
    @test size(etp) == size(img)
    @test eltype(etp) == eltype(img)
    @test etp.itp.it == BSpline(Constant{Nearest}())
    @test etp isa Interpolations.FilledExtrapolation
    @test etp.itp.coefs === img

    etp = @inferred ImageTransformations.box_extrapolation(img, method=Constant(), fillvalue=Flat())
    @test_nowarn summary(etp)
    @test size(etp) == size(img)
    @test eltype(etp) == eltype(img)
    @test etp.itp.it == BSpline(Constant{Nearest}())
    @test etp isa Interpolations.Extrapolation
    @test etp.et == Flat()
    @test etp.itp.coefs === img

    imgfloat = Float64.(img)
    etp = @inferred ImageTransformations.box_extrapolation(imgfloat, method=Quadratic(Flat(OnGrid())))
    @test_nowarn summary(etp)
    @test size(etp) == size(imgfloat)
    @test eltype(etp) == eltype(imgfloat)
    @test etp.itp.it == BSpline(Quadratic(Flat(OnGrid())))
    @test etp isa Interpolations.FilledExtrapolation

    etp = @inferred ImageTransformations.box_extrapolation(imgfloat, method=Cubic(Flat(OnGrid())), fillvalue=Flat())
    @test_nowarn summary(etp)
    @test size(etp) == size(imgfloat)
    @test eltype(etp) == eltype(imgfloat)
    @test etp.itp.it == BSpline(Cubic(Flat(OnGrid())))
    @test etp isa Interpolations.Extrapolation

    etp = @inferred ImageTransformations.box_extrapolation(imgfloat, method=Lanczos4OpenCV())
    @test_nowarn summary(etp)
    @test size(etp) == size(imgfloat)
    @test eltype(etp) == eltype(imgfloat)
    @test etp.itp.it == Lanczos4OpenCV()
    @test etp isa Interpolations.FilledExtrapolation
end

@testset "AxisAlgorithms.A_ldiv_B_md" begin
    # TODO
end

@testset "CornerIterator" begin
    # check that CornerIterator is not exported
    @test_throws UndefVarError CornerIterator

    # test interface and behaviour under normal circumstances
    # (i.e. without any singleton array dimension of size 1)
    si(num::Number) = 1
    ei(num::Number) = num
    si(num::AbstractRange)  = minimum(num)
    ei(num::AbstractRange)  = maximum(num)
    for t in ((2,), (2,3), (2,3,4), (2,3,4,5),        # OneTo
              (-1:2,), (-1:2,-2:3), (-1:2,-2:3,-3:4)) # Non OneTo
        N = length(t)
        @testset "$N-d array without singleton dimension" begin
            cr = CartesianIndices(t)
            ci = @inferred(ImageTransformations.CornerIterator(cr))
            @test typeof(ci) <: ImageTransformations.CornerIterator{CartesianIndex{N}}
            @test ci.start === first(cr)
            @test ci.stop === last(cr)
            @test @inferred(eltype(ci)) === CartesianIndex{N}
            @test @inferred(size(ci)) === ntuple(x->2, N)
            @test @inferred(length(ci)) === 2^N
            # Check for correct shape and values
            A = @inferred(collect(ci))
            @test typeof(A) <: Array{CartesianIndex{N},N}
            if N == 1
                @test A == [CartesianIndex{1}(si(t[1])), CartesianIndex{1}(ei(t[1]))]
            elseif N == 2
                @test A == [
                    CartesianIndex{2}(si(t[1]),si(t[2]))  CartesianIndex{2}(si(t[1]),ei(t[2]));
                    CartesianIndex{2}(ei(t[1]),si(t[2]))  CartesianIndex{2}(ei(t[1]),ei(t[2]));
                ]
            elseif N == 3
                for (i,v) in zip(1:2,[si(t[3]),ei(t[3])])
                    @test A[:,:,i] == [
                        CartesianIndex{3}(si(t[1]),si(t[2]),v)  CartesianIndex{3}(si(t[1]),ei(t[2]),v);
                        CartesianIndex{3}(ei(t[1]),si(t[2]),v)  CartesianIndex{3}(ei(t[1]),ei(t[2]),v);
                    ]
                end
            elseif N == 4
                for (i2,v2) in zip(1:2,[si(t[4]),ei(t[4])])
                    for (i1,v1) in zip(1:2,[si(t[3]),ei(t[3])])
                        @test A[:,:,i1,i2] == [
                            CartesianIndex{4}(si(t[1]),si(t[2]),v1,v2)  CartesianIndex{4}(si(t[1]),ei(t[2]),v1,v2);
                            CartesianIndex{4}(ei(t[1]),si(t[2]),v1,v2)  CartesianIndex{4}(ei(t[1]),ei(t[2]),v1,v2);
                        ]
                    end
                end
            else
                error("This code must be unreached")
            end
        end
    end

    @testset "0-element and 1-element edge cases" begin
        for t in ((),(1,),(1,1),(1,1,1))
            N = length(t)
            cr = CartesianIndices(t)
            ci = @inferred(ImageTransformations.CornerIterator(cr))
            @test ci.start === first(cr)
            @test ci.stop === last(cr)
            @test @inferred(collect(ci)) == collect(cr)
            @test @inferred(size(ci)) === t
            @test @inferred(length(ci)) === 1
            @test length(collect(ci)) === 1
            @test typeof(collect(ci)) <: Array{CartesianIndex{N},N}
            @test all(collect(ci) .== [CartesianIndex{N}(t)])
        end
    end

    @testset "arrays with singleton dimensions" begin
        cr = CartesianIndices((1,3))
        ci = @inferred(ImageTransformations.CornerIterator(cr))
        @test ci.start === first(cr)
        @test ci.stop === last(cr)
        @test @inferred(size(ci)) === (1,2)
        @test @inferred(length(ci)) === 2
        @test length(@inferred(collect(ci))) === 2
        @test typeof(collect(ci)) <: Array{CartesianIndex{2},2}
        @test collect(ci) == [
            CartesianIndex{2}((1,1)) CartesianIndex{2}((1,3))
        ]
        # two singleton dimensions
        cr = CartesianIndices((1,3,1,3))
        ci = @inferred(ImageTransformations.CornerIterator(cr))
        @test ci.start === first(cr)
        @test ci.stop === last(cr)
        @test @inferred(size(ci)) === (1,2,1,2)
        @test @inferred(length(ci)) === 4
        @test length(@inferred(collect(ci))) === 4
        @test typeof(collect(ci)) <: Array{CartesianIndex{4},4}
        @test size(collect(ci)) === (1,2,1,2)
        @test collect(ci)[1,:,1,:] == [
            CartesianIndex{4}((1,1,1,1)) CartesianIndex{4}((1,1,1,3));
            CartesianIndex{4}((1,3,1,1)) CartesianIndex{4}((1,3,1,3))
        ]
    end
end

@testset "autorange" begin
    for (h, w) in ((10,20), (20,10), (7,9))
        d = sqrt(h^2 + w^2)
        α = atand(h/w)
        tst_img = zeros(h,w)
        # We compare the result of autorange against manually computed
        # values using basic trigonometry
        for θ in 1:1:89
            rot = LinearMap(RotMatrix(deg2rad(θ)))
            rnge = @inferred ImageTransformations.autorange(tst_img, rot)
            @test rnge[1].start == floor(cosd(θ)*1 - sind(θ)*w)
            @test rnge[1].stop  ==  ceil(cosd(θ)*h - sind(θ)*1)
            @test rnge[2].start == 1
            @test rnge[2].stop  == ceil(cosd(α-θ)*d)
        end
    end
    # Non-1 indices
    for (indh, indw) in ((-1:10,0:20), (-1:20,-2:10), (0:7,-3:9))
        h, w = length(indh), length(indw)
        tst_img = OffsetArray(zeros(h,w), indh, indw)
        for θ in 1:1:89
            rot = LinearMap(RotMatrix(deg2rad(θ)))
            rnge = @inferred ImageTransformations.autorange(tst_img, rot)
            @test rnge[1].start == floor(cosd(θ)*first(indh) - sind(θ)*last(indw))
            @test rnge[1].stop  ==  ceil(cosd(θ)*last(indh)  - sind(θ)*first(indw))
            @test rnge[2].start == floor(sind(θ)*first(indh) + cosd(θ)*first(indw))
            @test rnge[2].stop  ==  ceil(sind(θ)*last(indh)  + cosd(θ)*last(indw))
        end
    end
    #should also work with non-static transforms (Github #48)
    tfm = LinearMap(Matrix(1.0*I,2,2))
    tfm_s = LinearMap(SMatrix{2,2}(Matrix(1.0*I,2,2)))
    tst_img = zeros(5,5)
    rnge = ImageTransformations.autorange(tst_img, tfm_s)
    @test rnge == ImageTransformations.autorange(tst_img, tfm)
    # ComposedFunction (issue #110)
    M = @SMatrix [1 0 0; 0 1 0; -1/1000 0 1] 
    push1(x) = push(x, 1)
    tfm = PerspectiveMap() ∘ inv(LinearMap(M)) ∘ push1
    tst_img = zeros(5, 5)
    @test ImageTransformations.autorange(tst_img, tfm) == (0:5, 0:5)
end

# A helper function to let our `method` keyword correctly understands `Degree` inputs.
@inline wrap_BSpline(itp::Interpolations.InterpolationType) = itp
@inline wrap_BSpline(degree::Interpolations.Degree) = BSpline(degree)

# The default values used by extrapolation for off-domain points
const FillType = Union{Number,Colorant,Flat,Periodic,Reflect}
const FloatLike{T<:AbstractFloat} = Union{T,AbstractGray{T}}
const FloatColorant{T<:AbstractFloat} = Colorant{T}
@inline _default_fillvalue(::Type{T}) where {T<:FloatLike} = convert(T, NaN)
@inline _default_fillvalue(::Type{T}) where {T<:FloatColorant} = _nan(T)
@inline _default_fillvalue(::Type{T}) where {T} = zero(T)

@inline _make_compatible(T, fill) = fill
@inline _make_compatible(::Type{T}, fill::Number) where {T} = T(fill)

Interpolations.tweight(A::AbstractArray{C}) where C<:Colorant{T} where T = T

const MethodType = Union{Interpolations.Degree, Interpolations.InterpolationType}

function box_extrapolation(
        parent::AbstractArray;
        fillvalue::FillType = _default_fillvalue(eltype(parent)),
        method=Linear(),
        kwargs...)
    T = typeof(zero(Interpolations.tweight(parent)) * zero(eltype(parent)))
    itp = maybe_skip_prefilter(T, parent, method)
    extrapolate(itp, _make_compatible(T, fillvalue))
end
box_extrapolation(etp::AbstractExtrapolation) = etp
box_extrapolation(itp::AbstractInterpolation{T}; fillvalue=_default_fillvalue(T)) where T =
    extrapolate(itp, _make_compatible(T, fillvalue))

@inline function maybe_skip_prefilter(::Type{T}, A::AbstractArray, degree::D) where {T, D<:Union{Linear, Constant}}
    axs = axes(A)
    return Interpolations.BSplineInterpolation{T,ndims(A),typeof(A),BSpline{D},typeof(axs)}(A, axs, BSpline(degree))
end
@inline function maybe_skip_prefilter(::Type{T}, A::AbstractArray, method::BSpline{D}) where {T, D<:Union{Linear, Constant}}
    maybe_skip_prefilter(T, A, method.degree)
end

@inline function maybe_skip_prefilter(::Type{T}, A::AbstractArray, method::MethodType) where T
    return interpolate(A, wrap_BSpline(method))
end

# This is type-piracy, but necessary if we want Interpolations to be
# independent of OffsetArrays.
function AxisAlgorithms.A_ldiv_B_md!(dest::OffsetArray, F, src::OffsetArray, dim::Integer, b::AbstractVector)
    indsdim = axes(parent(src), dim)
    indsF = axes(F)[2]
    if indsF == indsdim
        AxisAlgorithms.A_ldiv_B_md!(parent(dest), F, parent(src), dim, b)
        return dest
    end
    throw(DimensionMismatch("indices $(axes(parent(src))) do not match $(axes(F))"))
end

# ---
# cover: assets/swirl.gif
# title: Swirl effect using warp operation
# author: Johnny Chen
# date: 2021-07-12
# ---

# In this example, we illustrate how to construct a custom warping map
# and pass it to `warp`. This swirl example comes from
# [the Princeton Computer Graphics course for Image Warping (Fall 2000)](https://www.cs.princeton.edu/courses/archive/fall00/cs426/lectures/warp/warp.pdf)
# and [scikit-image swirl example](https://scikit-image.org/docs/dev/auto_examples/transform/plot_swirl.html).

using ImageTransformations
using OffsetArrays, StaticArrays
using ImageShow, TestImages
using LinearAlgebra

img = imresize(testimage("cameraman"), (256, 256));

# As we've illustrated in [image warping](@ref index_image_warping), a warp operation
# consists of two operations: backward coordinate map `ϕ` and intensity estimator.
# To implement swirl operation, we need to customize the coordinate map `ϕ`.
# A valid coordinate map `q = ϕ(p)` follows the following interface:
#
# ```julia
# # SVector comes from StaticArrays
# ϕ(::SVector{N})::SVector{N} where N
# ```
#
# A cartesian position `(x, y)` can be transfered to/from polar coordinate `(ρ, θ)`
# using formula:
#
# ```julia
# # Cartesian to Polar
# ρ = norm(y-y0, x-x0)
# θ = atan(y/x)
#
# # Polar to Cartesian
# y = y0 + ρ*sin(θ)
# x = x0 + ρ*cos(θ)
# ```
#
# For given input index `p`, a swirl operation enforces more rotations in its polar coordinate using
# `θ̃ = θ + ϕ + s*exp(-ρ/r)`, and returns the cartesian index (x̃, ỹ) from the warped polor coordinate
# (ρ, θ̃). (Here we use the formula from [scikit-image swirl example](https://scikit-image.org/docs/dev/auto_examples/transform/plot_swirl.html)
# to build our version.)

function swirl(rotation, strength, radius)
    x0 = OffsetArrays.center(img)
    r = log(2)*radius/5

    function swirl_map(x::SVector{N}) where N
        xd = x .- x0
        ρ = norm(xd)
        θ = atan(reverse(xd)...)

        ## Note that `x == x0 .+ ρ .* reverse(sincos(θ))`
        ## swirl adds more rotations to θ based on the distance to center point
        θ̃ = θ + rotation + strength * exp(-ρ/r)
        
        SVector{N}(x0 .+ ρ .* reverse(sincos(θ̃)))
    end

    warp(img, swirl_map, axes(img))
end

# Now let's see how radius argument affects the result

preview = ImageShow.gif([swirl(0, 10, radius) for radius in 10:10:150]; fps=5)

using FileIO #src
save("assets/swirl.gif", preview; fps=5) #src

using CoordinateTransformations, Rotations, TestImages, ImageCore, StaticArrays, OffsetArrays, Interpolations, LinearAlgebra
using Test, ReferenceTests

refambs = detect_ambiguities(CoordinateTransformations, Base, Core)
using ImageTransformations
ambs = detect_ambiguities(ImageTransformations, CoordinateTransformations, Base, Core)
@test isempty(setdiff(ambs, refambs))

# helper function to compare NaN
nearlysame(x, y) = x ≈ y || (isnan(x) & isnan(y))
nearlysame(A::AbstractArray, B::AbstractArray) = all(map(nearlysame, A, B))

tests = [
    "autorange.jl",
    "resizing.jl",
    "interpolations.jl",
    "warp.jl",
    "deprecated.jl" # test deprecations in the last
]

@testset "ImageTransformations" begin
for t in tests
    @testset "$t" begin
        include(t)
    end
end
end

nothing

# This file includes two kinds of codes
#   - Codes for backward compatibility
#   - Glue codes that might no longer be necessary in the future

@static if VERSION < v"1.1"
    @inline isnothing(x) = x === nothing
end

if hasmethod(nan, Tuple{Type{HSV{Float32},}})
    # requires ColorTypes v0.11 and ColorVectorSpace v0.9.4
    # https://github.com/JuliaGraphics/ColorVectorSpace.jl/issues/75
    @inline _nan(::Type{T}) where T = nan(T)
else
    @inline _nan(::Type{HSV{Float16}}) = HSV{Float16}(NaN16,NaN16,NaN16)
    @inline _nan(::Type{HSV{Float32}}) = HSV{Float32}(NaN32,NaN32,NaN32)
    @inline _nan(::Type{HSV{Float64}}) = HSV{Float64}(NaN,NaN,NaN)
    @inline _nan(::Type{T}) where {T} = nan(T)
end

using CoordinateTransformations, Rotations, TestImages, ImageCore, StaticArrays, OffsetArrays, Interpolations, LinearAlgebra
using EndpointRanges
using Tau
using Test, ReferenceTests

include("twoints.jl")

img_camera = testimage("camera")
@testset "Interface tests" begin
    tfm = recenter(RotMatrix(pi/8), center(img_camera))
    ref_inds = (-78:591, -78:591)
    ref_size = map(length,ref_inds)

    @testset "warp" begin
        imgr = @inferred(warp(img_camera, tfm))
        @test typeof(imgr) <: OffsetArray
        @test axes(imgr) == ref_inds
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg.txt" imgr

        imgr2 = imgr[axes(img_camera)...]
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr2

        imgr = @inferred(warp(img_camera, tfm, axes(img_camera)))
        @test typeof(imgr) <: Array
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr

        imgr = @inferred(warp(img_camera, tfm, axes(img_camera); fillvalue=1))
        @test typeof(imgr) <: Array
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(warp(img_camera, tfm, axes(img_camera); method=Linear(), fillvalue=1))
        @test typeof(imgr) <: Array
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(warp(img_camera, tfm; fillvalue=1))
        @test typeof(imgr) <: OffsetArray
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_white.txt" imgr
        imgr2 = @inferred warp(imgr, inv(tfm))
        @test eltype(imgr2) == eltype(img_camera)
        @test_reference "reference/warp_cameraman.txt" imgr2[axes(img_camera)...]
        # look the same but are not similar enough to pass test
        # @test imgr2[axes(img_camera)...] ≈ img_camera

        imgr = @inferred(warp(img_camera, tfm; fillvalue=Flat()))
        @test typeof(imgr) <: OffsetArray
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr
        imgr = @inferred(warp(img_camera, tfm, ref_inds; fillvalue=Flat()))
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr

        imgr = @inferred(warp(img_camera, tfm; method=Constant(), fillvalue=Periodic()))
        @test typeof(imgr) <: OffsetArray
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr
        imgr = @inferred(warp(img_camera, tfm, ref_inds; method=Constant(), fillvalue=Periodic()))
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr

        # Ensure that dynamic arrays work as transformations
        tfmd = AffineMap(Matrix(tfm.linear), Vector(tfm.translation))
        imgrd = @inferred(warp(img_camera, tfmd))
        imgrd = warp(img_camera, tfmd)
        @test imgrd == warp(img_camera, tfm)
        tfmd = LinearMap(Matrix(tfm.linear))
        @test @inferred(warp(img_camera, tfmd)) == warp(img_camera, LinearMap(tfm.linear))
        tfmd = Translation([-2, 2])
        @test @inferred(warp(img_camera, tfmd)) == warp(img_camera, Translation(-2, 2))
        @test_throws DimensionMismatch warp(img_camera, Translation([1,2,3]))

        # Since Translation can be constructed from any iterable, check that we support this too.
        # (This ensures the fallback for `_getindex` gets called even if we fix the issue by other means)
        tfmt = Translation(TwoInts(1, 2))
        @test tfmt isa Translation{TwoInts}
        imgt = warp(img_camera, tfmt)  # not necessarily inferrable, that's OK
        @test imgt == warp(img_camera, Translation(1,2))
    end

    @testset "WarpedView" begin
        imgr = @inferred(WarpedView(img_camera, tfm))
        @test_nowarn summary(imgr)
        @test @inferred(getindex(imgr,2,2)) == imgr[2,2]
        @test typeof(imgr[2,2]) == eltype(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: WarpedView
        @test axes(imgr) == ref_inds
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg.txt" imgr

        imgr2 = imgr[axes(img_camera)...]
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr2

        imgr = @inferred(WarpedView(img_camera, tfm, axes(img_camera)))
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test @inferred(size(imgr,3)) == 1
        @test parent(imgr) === img_camera
        @test axes(imgr) === axes(img_camera)
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr

        imgr = @inferred(WarpedView(img_camera, tfm, axes(img_camera); fillvalue=1))
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test @inferred(size(imgr,3)) == 1
        @test parent(imgr) === img_camera
        @test axes(imgr) === axes(img_camera)
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(WarpedView(img_camera, tfm, axes(img_camera); method=Linear(), fillvalue=1))
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test @inferred(size(imgr,3)) == 1
        @test parent(imgr) === img_camera
        @test axes(imgr) === axes(img_camera)
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(WarpedView(img_camera, tfm; fillvalue=1))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_white.txt" imgr
        imgr2 = @inferred WarpedView(imgr, inv(tfm))
        @test eltype(imgr2) == eltype(img_camera)
        @test_reference "reference/warp_cameraman.txt" imgr2[axes(img_camera)...]
        # look the same but are not similar enough to pass test
        # @test imgr2[axes(img_camera)...] ≈ img_camera

        imgr = @inferred(WarpedView(img_camera, tfm; fillvalue=Flat()))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr
        imgr = @inferred(WarpedView(img_camera, tfm, ref_inds; fillvalue=Flat()))
        @test eltype(imgr) == eltype(img_camera)
        @test axes(imgr) === ref_inds
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr

        imgr = @inferred(WarpedView(img_camera, tfm; method=Constant(), fillvalue=Periodic()))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: WarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr

        imgr = @inferred(WarpedView(img_camera, tfm, ref_inds; method=Constant(), fillvalue=Periodic()))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr
    end

    tfm = recenter(RotMatrix(-pi/8), center(img_camera))
    @testset "invwarpedview" begin
        wv = @inferred(InvWarpedView(img_camera, tfm))
        @test wv ≈ @inferred(InvWarpedView(WarpedView(img_camera, inv(tfm))))
        @test_reference "reference/invwarpedview_cameraman_rotate_r22deg.txt" wv
        @test size(wv) == ref_size
        @test axes(wv) == ref_inds
        @test eltype(wv) === eltype(img_camera)
        @test parent(wv) === img_camera

        # check nested transformation using the inverse
        wv2 = @inferred(InvWarpedView(wv, inv(tfm)))
        @test axes(wv2) == axes(img_camera)
        @test eltype(wv2) === eltype(img_camera)
        @test parent(wv2) === img_camera
        @test_skip wv2 ≈ img_camera      # see discussion in #143
        @test wv2[ibegin+1:iend-1,ibegin+1:iend-1] ≈ img_camera[ibegin+1:iend-1,ibegin+1:iend-1]  # TODO: change to begin/end, drop EndpointRanges

        imgr = @inferred(InvWarpedView(img_camera, tfm))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test typeof(imgr) <: InvWarpedView
        @test parent(imgr) === img_camera
        @test axes(imgr) == ref_inds
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg.txt" imgr

        imgr2 = imgr[axes(img_camera)...]
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr2

        imgr = @inferred(InvWarpedView(img_camera, tfm, axes(img_camera)))
        @test imgr2 == imgr
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test axes(imgr) === axes(img_camera)
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm, axes(img_camera); fillvalue=1))
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm, axes(img_camera); method=Linear(), fillvalue=1))
        @test_nowarn summary(imgr)
        @test @inferred(size(imgr)) == size(img_camera)
        @test parent(imgr) === img_camera
        @test axes(imgr) === axes(img_camera)
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_crop_white.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm; fillvalue=1))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test axes(imgr) === ref_inds
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_white.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm; fillvalue=Flat()))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr
        imgr = @inferred(InvWarpedView(img_camera, tfm, ref_inds; fillvalue=Flat()))
        @test parent(imgr) === img_camera
        @test eltype(imgr) == eltype(img_camera)
        @test axes(imgr) === ref_inds
        @test_reference "reference/warp_cameraman_rotate_r22deg_flat.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm; method=Constant(), fillvalue=Periodic()))
        @test_nowarn summary(imgr)
        @test size(imgr) == ref_size
        @test axes(imgr) == ref_inds
        @test parent(imgr) === img_camera
        @test typeof(imgr) <: InvWarpedView
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr

        imgr = @inferred(InvWarpedView(img_camera, tfm, ref_inds; method=Constant(), fillvalue=Periodic()))
        @test_nowarn summary(imgr)
        @test parent(imgr) === img_camera
        @test size(imgr) == ref_size
        @test axes(imgr) == ref_inds
        @test eltype(imgr) == eltype(img_camera)
        @test_reference "reference/warp_cameraman_rotate_r22deg_periodic.txt" imgr
    end

    @testset "InvWarpedView on SubArray" begin
        tfm = recenter(RotMatrix(-pi/8), center(img_camera))
        img = similar(img_camera)
        v = view(img, 75:195, 245:370)
        v .= view(img_camera, v.indices...)

        wv = InvWarpedView(v, tfm)
        @test wv isa InvWarpedView
        @test parent(wv) == v
        @test axes(wv) == (-78:82, 72:234)
        # boundaries are filled with 0 values
        @test all(wv[first(axes(wv, 1)), :] .== 0)
        @test all(wv[last(axes(wv, 1)), :] .== 0)
        @test all(wv[:, first(axes(wv, 2))] .== 0)
        @test all(wv[:, last(axes(wv, 2))] .== 0)

        # Out-of-domain values are not used to generate the warp view
        v = view(img_camera, 75:195, 245:370)
        wv2 = InvWarpedView(v, tfm)
        @test wv2 == wv == warp(v, inv(tfm))
    end

    @testset "3d warps" begin
        img = testimage("mri")
        θ = π/8
        tfm = AffineMap(RotZ(θ), (I - RotZ(θ))*center(img))
        imgr = WarpedView(img, tfm, axes(img))
        @test axes(imgr) == axes(img)
    end
end

img_pyramid = Gray{Float64}[
    0.0 0.0 0.0 0.0 0.0;
    0.0 0.5 0.5 0.5 0.0;
    0.0 0.5 1.0 0.5 0.0;
    0.0 0.5 0.5 0.5 0.0;
    0.0 0.0 0.0 0.0 0.0;
]
img_pyramid_cntr = OffsetArray(img_pyramid, -2:2, -2:2)
ref_img_pyramid = Float64[
    NaN   NaN   NaN   NaN   NaN   NaN   NaN;
    NaN   NaN   NaN  0.172  NaN   NaN   NaN;
    NaN   NaN  0.293 0.543 0.293  NaN   NaN;
    NaN  0.172 0.543 1.000 0.543 0.172  NaN;
    NaN   NaN  0.293 0.543 0.293  NaN   NaN;
    NaN   NaN   NaN  0.172  NaN   NaN   NaN;
    NaN   NaN   NaN   NaN   NaN   NaN   NaN;
]
ref_img_pyramid_quad = Float64[
    NaN      NaN      NaN      0.003    NaN      NaN      NaN;
    NaN      NaN     -0.038    0.205   -0.038    NaN      NaN;
    NaN     -0.038    0.255    0.635    0.255   -0.038    NaN;
    0.003    0.205    0.635    1.0      0.635    0.205    0.003;
    NaN     -0.038    0.255    0.635    0.255   -0.038    NaN;
    NaN      NaN     -0.038    0.205   -0.038    NaN      NaN;
    NaN      NaN      NaN      0.003    NaN      NaN      NaN;
]
ref_img_pyramid_grid = Float64[
    NaN  NaN         NaN         NaN         NaN         NaN         NaN;
    NaN  NaN         NaN           0.157977  NaN         NaN         NaN;
    NaN  NaN           0.223858    0.654962    0.223858  NaN         NaN;
    NaN    0.157977    0.654962    1.0         0.654962    0.157977  NaN;
    NaN  NaN           0.223858    0.654962    0.223858  NaN         NaN;
    NaN  NaN         NaN           0.157977  NaN         NaN         NaN;
    NaN  NaN         NaN         NaN         NaN         NaN         NaN;
]
ref_img_pyramid_lanczos = Float64[
NaN  NaN      NaN      NaN      NaN      NaN      NaN
NaN  NaN      NaN        0.204  NaN      NaN      NaN
NaN  NaN        0.22     0.649    0.22   NaN      NaN
NaN    0.204    0.649    1.0      0.649    0.204  NaN
NaN  NaN        0.22     0.649    0.22   NaN      NaN
NaN  NaN      NaN        0.204  NaN      NaN      NaN
NaN  NaN      NaN      NaN      NaN      NaN      NaN
]
@testset "Result against reference" begin

    tfm1 = recenter(RotMatrix(pi/4), center(img_pyramid))
    tfm2 = LinearMap(RotMatrix(pi/4))

    @testset "warp" begin
        imgr = warp(img_pyramid, tfm1)
        @test axes(imgr) == (0:6, 0:6)
        @test eltype(imgr) == eltype(img_pyramid)
        # Use map and === because of the NaNs
        @test nearlysame(round.(Float64.(parent(imgr)), digits=3), round.(ref_img_pyramid,digits=3))

        # https://discourse.julialang.org/t/translate-images-by-subpixel-amounts/30248/4
        a = [1 2 3; 4 5 6]
        t = Translation(.9, .9)
        b = warp(a, t, indices_spatial(a); fillvalue=0)
        @test b[1,1] ≈ 0.9^2*5 + 0.1*0.9*(4+2) + 0.1^2*1

        @testset "OffsetArray" begin
            imgr_cntr = warp(img_pyramid_cntr, tfm2)
            @test axes(imgr_cntr) == (-3:3, -3:3)
            @test nearlysame(parent(imgr_cntr), parent(imgr))

            imgr_cntr = warp(img_pyramid_cntr, tfm2, (-1:1,-1:1))
            @test axes(imgr_cntr) == (-1:1, -1:1)
            @test nearlysame(parent(imgr_cntr), imgr[2:4,2:4])
        end

        @testset "Method kwarg" begin
            imgr_cntr = warp(img_pyramid_cntr, tfm2, method=Linear())
            @test axes(imgr_cntr) == (-3:3, -3:3)
            @test nearlysame(parent(warp(img_pyramid_cntr, tfm2)), parent(warp(img_pyramid_cntr, tfm2, method=Linear())))

            imgr_cntr = warp(img_pyramid_cntr, tfm2, (-1:1,-1:1), method=Linear())
            @test axes(imgr_cntr) == (-1:1, -1:1)
            @test nearlysame(parent(imgr_cntr), imgr[2:4,2:4])

            imgr_cntr = warp(img_pyramid_cntr, tfm2, method=BSpline(Linear()))
            @test axes(imgr_cntr) == (-3:3, -3:3)
            @test nearlysame(parent(imgr_cntr), parent(imgr))

            imgr_cntr = warp(img_pyramid_cntr, tfm2, (-1:1, -1:1), method=BSpline(Linear()))
            @test axes(imgr_cntr) == (-1:1, -1:1)
            @test nearlysame(parent(imgr_cntr), imgr[2:4,2:4])

            imgr_cntr = warp(img_pyramid_cntr, tfm2, method=Lanczos4OpenCV())
            @test axes(imgr_cntr) == (-3:3, -3:3)
            @test nearlysame(round.(Float64.(parent(imgr_cntr)), digits=3), round.(ref_img_pyramid_lanczos, digits=3))
        end

        @testset "Quadratic Interpolation" begin
            itp = interpolate(img_pyramid_cntr, BSpline(Quadratic(Flat(OnCell()))))
            imgrq_cntr = warp(itp, tfm2)
            @test axes(imgrq_cntr) == (-3:3, -3:3)
            @test nearlysame(round.(Float64.(parent(imgrq_cntr)), digits=3), round.(ref_img_pyramid_quad, digits=3))

            imgrq_cntr = warp(img_pyramid_cntr, tfm2, method=Quadratic(Flat(OnGrid())))
            @test axes(imgrq_cntr) == (-3:3, -3:3)
            @test nearlysame(round.(Float64.(parent(imgrq_cntr)), digits=3), round.(ref_img_pyramid_grid, digits=3))
        end
    end

    @testset "InvWarpedView" begin
        imgr = InvWarpedView(img_pyramid, inv(tfm1))
        @test axes(imgr) == (0:6, 0:6)
        # Use map and === because of the NaNs
        @test nearlysame(round.(Float64.(imgr[0:6, 0:6]), digits=3), round.(ref_img_pyramid, digits=3))

        @testset "OffsetArray" begin
            imgr_cntr = InvWarpedView(img_pyramid_cntr, inv(tfm2))
            @test axes(imgr_cntr) == (-3:3, -3:3)
            @test nearlysame(imgr_cntr[axes(imgr_cntr)...], imgr[axes(imgr)...])
        end

        @testset "Quadratic Interpolation" begin
            itp = interpolate(img_pyramid_cntr, BSpline(Quadratic(Flat(OnCell()))))
            imgrq_cntr = InvWarpedView(itp, inv(tfm2))
            @test parent(imgrq_cntr) === itp
            @test_nowarn summary(imgrq_cntr)
            @test axes(imgrq_cntr) == (-3:3, -3:3)
            @test eltype(imgrq_cntr) == eltype(img_pyramid_cntr)

            @test nearlysame(round.(Float64.(imgrq_cntr[axes(imgrq_cntr)...]), digits=3), round.(ref_img_pyramid_quad, digits=3))
        end
    end

    @testset "imrotate" begin
    # imrotate is a wrapper, hence only need to guarantee the interface works as expected

        test_types = (Float32, Float64, N0f8, N0f16)
        graybar = repeat(range(0,stop=1,length=100),1,100)
        @testset "interface" begin
            for T in test_types
                img = Gray{T}.(graybar)
                @test_nowarn imrotate(img, π/4)
                @test_nowarn imrotate(img, π/4, method=Linear())
                @test_nowarn imrotate(img, π/4, method=Lanczos4OpenCV())

                @test_nowarn imrotate(img, π/4, axes(img))
                @test_nowarn imrotate(img, π/4, axes(img), method=Constant())
                @test_nowarn imrotate(img, π/4, axes(img), method=Constant(), fillvalue=1)

                @test nearlysame(imrotate(img, π/4, method=Linear()), imrotate(img, π/4, method=BSpline(Linear())))
                @test nearlysame(imrotate(img, π/4), imrotate(img, π/4; method=Linear(), fillvalue= ImageTransformations._default_fillvalue(eltype(T))))
            end
        end

        @testset "numerical" begin
            for T in test_types
                img = Gray{T}.(graybar)
                for θ in range(0,stop=2π,length = 100)
                    @test nearlysame(imrotate(img,θ), imrotate(img,θ+2π))
                end
            end
        end

        @testset "issue #147" begin
            img = Float64[1 2 3 4; 5 6 7 8; 9 10 11 12; 13 14 15 16]
            trfm = recenter(RotMatrix(pi/2), center(img))
            @test imrotate(img, π/2) ≈ warp(img, trfm) ≈ rotr90(img)
            @test  any(isnan, imrotate(img, π/3))
            @test !any(isnan, imrotate(img, π/3; fillvalue=0.0))
            @test !any(isnan, imrotate(img, π/3, fillvalue=0.0))
            @test  any(isnan, imrotate(img, π/3, axes(img)))
            @test !any(isnan, imrotate(img, π/3, axes(img); fillvalue=0.0))
            @test !any(isnan, imrotate(img, π/3, axes(img), fillvalue=0.0))
        end

        @testset "Examples from #79" begin
            @test axes(imrotate(img_camera, pi/2)) == axes(img_camera)
            @test imrotate(imrotate(imrotate(imrotate(img_camera, pi/2), pi/2), pi/2), pi/2) ≈ img_camera
            @test imrotate(imrotate(img_camera, pi), pi) == img_camera
            # Also check a "generic" irrational (one that happens to be quite special)
            ## First, check that this hits the generic code path (if we change that, pick a different irrational)
            @test ImageTransformations._mod2pi(τ) isa Float64
            ## Now check that it gives the expected result
            @test imrotate(img_camera, τ) ≈ img_camera

            # check special rotation degrees
            img = rand(Gray{N0f8}, 100, 50)
            @test size(imrotate(img, pi/2)) == (50, 100)
            @test size(imrotate(img, pi)) == (100, 50)
            @test size(imrotate(img, 3pi/2)) == (50, 100)
            @test size(imrotate(img, 2pi)) == (100, 50)
        end

        @testset "issue #154" begin
            img = rand(Gray{N0f8}, 100, 50)
            @test imrotate(img, pi) == imrotate(img, 1.0 * pi)
        end
    end
end

using ImageTransformations: box_extrapolation

@testset "deprecations" begin
    @info "deprecation warnings are expected"

    @testset "imrotate" begin
        # deprecate potionsal arguments in favor of keyword arguments
        img = repeat(range(0,stop=1,length=100), 1, 100)

        @test nearlysame(imrotate(img, π/4, Constant()),                imrotate(img, π/4, method=Constant()))
        @test nearlysame(imrotate(img, π/4, Constant(), 1),             imrotate(img, π/4, method=Constant(), fillvalue=1))
        @test nearlysame(imrotate(img, π/4, 1, Constant()),             imrotate(img, π/4, method=Constant(), fillvalue=1))
        @test nearlysame(imrotate(img, π/4, 1),                         imrotate(img, π/4, fillvalue=1))
        @test nearlysame(imrotate(img, π/4, Periodic()),                imrotate(img, π/4, fillvalue=Periodic()))

        @test nearlysame(imrotate(img, π/4, axes(img), Constant()),     imrotate(img, π/4, axes(img), method=Constant()))
        @test nearlysame(imrotate(img, π/4, axes(img), Constant(), 1),  imrotate(img, π/4, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(imrotate(img, π/4, axes(img), 1, Constant()),  imrotate(img, π/4, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(imrotate(img, π/4, axes(img), 1),              imrotate(img, π/4, axes(img), fillvalue=1))
        @test nearlysame(imrotate(img, π/4, axes(img), Periodic()),     imrotate(img, π/4, axes(img), fillvalue=Periodic()))
    end

    @testset "warp" begin
        # deprecate potionsal arguments in favor of keyword arguments
        img = repeat(range(0,stop=1,length=100), 1, 100)
        tfm = recenter(RotMatrix(pi/8), center(img))

        @test nearlysame(warp(img, tfm, Constant()),                warp(img, tfm, method=Constant()))
        @test nearlysame(warp(img, tfm, Constant(), 1),             warp(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(warp(img, tfm, 1, Constant()),             warp(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(warp(img, tfm, 1),                         warp(img, tfm, fillvalue=1))
        @test nearlysame(warp(img, tfm, Periodic()),                warp(img, tfm, fillvalue=Periodic()))

        @test nearlysame(warp(img, tfm, axes(img), Constant()),     warp(img, tfm, axes(img), method=Constant()))
        @test nearlysame(warp(img, tfm, axes(img), Constant(), 1),  warp(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(warp(img, tfm, axes(img), 1, Constant()),  warp(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(warp(img, tfm, axes(img), 1),              warp(img, tfm, axes(img), fillvalue=1))
        @test nearlysame(warp(img, tfm, axes(img), Periodic()),     warp(img, tfm, axes(img), fillvalue=Periodic()))
    end

    @testset "warpedview" begin
        # deprecate `warpedview` in favor of `WarpedView`
        img = repeat(range(0,stop=1,length=100), 1, 100)
        tfm = recenter(RotMatrix(pi/8), center(img))

        @test nearlysame(warpedview(img, tfm, Constant()),                WarpedView(img, tfm, method=Constant()))
        @test nearlysame(warpedview(img, tfm, Constant(), 1),             WarpedView(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(warpedview(img, tfm, 1, Constant()),             WarpedView(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(warpedview(img, tfm, 1),                         WarpedView(img, tfm, fillvalue=1))
        @test nearlysame(warpedview(img, tfm, Periodic()),                WarpedView(img, tfm, fillvalue=Periodic()))

        @test nearlysame(warpedview(img, tfm, axes(img), Constant()),     WarpedView(img, tfm, axes(img), method=Constant()))
        @test nearlysame(warpedview(img, tfm, axes(img), Constant(), 1),  WarpedView(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(warpedview(img, tfm, axes(img), 1, Constant()),  WarpedView(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(warpedview(img, tfm, axes(img), 1),              WarpedView(img, tfm, axes(img), fillvalue=1))
        @test nearlysame(warpedview(img, tfm, axes(img), Periodic()),     WarpedView(img, tfm, axes(img), fillvalue=Periodic()))
    end

    @testset "WarpedView" begin
        # deprecate potionsal arguments in favor of keyword arguments
        img = repeat(range(0,stop=1,length=100), 1, 100)
        tfm = recenter(RotMatrix(pi/8), center(img))

        @test nearlysame(WarpedView(img, tfm, Constant()),                WarpedView(img, tfm, method=Constant()))
        @test nearlysame(WarpedView(img, tfm, Constant(), 1),             WarpedView(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, 1, Constant()),             WarpedView(img, tfm, method=Constant(), fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, 1),                         WarpedView(img, tfm, fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, Periodic()),                WarpedView(img, tfm, fillvalue=Periodic()))

        @test nearlysame(WarpedView(img, tfm, axes(img), Constant()),     WarpedView(img, tfm, axes(img), method=Constant()))
        @test nearlysame(WarpedView(img, tfm, axes(img), Constant(), 1),  WarpedView(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, axes(img), 1, Constant()),  WarpedView(img, tfm, axes(img), method=Constant(), fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, axes(img), 1),              WarpedView(img, tfm, axes(img), fillvalue=1))
        @test nearlysame(WarpedView(img, tfm, axes(img), Periodic()),     WarpedView(img, tfm, axes(img), fillvalue=Periodic()))
    end

    @testset "invwarpedview" begin
        # deprecate potionsal arguments in favor of keyword arguments
        img = repeat(range(0,stop=1,length=100), 1, 100)
        tfm = recenter(RotMatrix(pi/8), center(img))
        
        @test nearlysame(invwarpedview(img, tfm, Constant()),                InvWarpedView(box_extrapolation(img; method=Constant()), tfm))
        @test nearlysame(invwarpedview(img, tfm, Constant(), 1),             InvWarpedView(box_extrapolation(img; method=Constant(), fillvalue=1), tfm))
        @test nearlysame(invwarpedview(img, tfm, 1, Constant()),             InvWarpedView(box_extrapolation(img; method=Constant(), fillvalue=1), tfm))
        @test nearlysame(invwarpedview(img, tfm, 1),                         InvWarpedView(box_extrapolation(img; fillvalue=1), tfm))
        @test nearlysame(invwarpedview(img, tfm, Periodic()),                InvWarpedView(box_extrapolation(img; fillvalue=Periodic()), tfm))

        @test nearlysame(InvWarpedView(img, tfm, Constant()),                InvWarpedView(img, tfm; method=Constant()))
        @test nearlysame(InvWarpedView(img, tfm, Constant(), 1),             InvWarpedView(img, tfm; method=Constant(), fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, 1, Constant()),             InvWarpedView(img, tfm; method=Constant(), fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, 1),                         InvWarpedView(img, tfm; fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, Periodic()),                InvWarpedView(img, tfm; fillvalue=Periodic()))

        @test nearlysame(invwarpedview(img, tfm, axes(img), Constant()),                InvWarpedView(box_extrapolation(img; method=Constant()), tfm, axes(img)))
        @test nearlysame(invwarpedview(img, tfm, axes(img), Constant(), 1),             InvWarpedView(box_extrapolation(img; method=Constant(), fillvalue=1), tfm, axes(img)))
        @test nearlysame(invwarpedview(img, tfm, axes(img), 1, Constant()),             InvWarpedView(box_extrapolation(img; method=Constant(), fillvalue=1), tfm, axes(img)))
        @test nearlysame(invwarpedview(img, tfm, axes(img), 1),                         InvWarpedView(box_extrapolation(img; fillvalue=1), tfm, axes(img)))
        @test nearlysame(invwarpedview(img, tfm, axes(img), Periodic()),                InvWarpedView(box_extrapolation(img; fillvalue=Periodic()), tfm, axes(img)))

        @test nearlysame(InvWarpedView(img, tfm, axes(img), Constant()),                InvWarpedView(img, tfm, axes(img); method=Constant()))
        @test nearlysame(InvWarpedView(img, tfm, axes(img), Constant(), 1),             InvWarpedView(img, tfm, axes(img); method=Constant(), fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, axes(img), 1, Constant()),             InvWarpedView(img, tfm, axes(img); method=Constant(), fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, axes(img), 1),                         InvWarpedView(img, tfm, axes(img); fillvalue=1))
        @test nearlysame(InvWarpedView(img, tfm, axes(img), Periodic()),                InvWarpedView(img, tfm, axes(img); fillvalue=Periodic()))
    end
end

# BEGIN 0.9 deprecations

@deprecate warp(img::AbstractArray, tform::Transformation,       method::MethodType,                      ) warp(img, tform; method=method)
@deprecate warp(img::AbstractArray, tform::Transformation,                             fillvalue::FillType) warp(img, tform; fillvalue=fillvalue)
@deprecate warp(img::AbstractArray, tform::Transformation,       method::MethodType,   fillvalue::FillType) warp(img, tform; method=method, fillvalue=fillvalue)
@deprecate warp(img::AbstractArray, tform::Transformation,       fillvalue::FillType,   method::MethodType) warp(img, tform; method=method, fillvalue=fillvalue)
@deprecate warp(img::AbstractArray, tform::Transformation, inds, method::MethodType,                      ) warp(img, tform, inds; method=method)
@deprecate warp(img::AbstractArray, tform::Transformation, inds,                       fillvalue::FillType) warp(img, tform, inds; fillvalue=fillvalue)
@deprecate warp(img::AbstractArray, tform::Transformation, inds, method::MethodType,   fillvalue::FillType) warp(img, tform, inds; method=method, fillvalue=fillvalue)
@deprecate warp(img::AbstractArray, tform::Transformation, inds, fillvalue::FillType,   method::MethodType) warp(img, tform, inds; method=method, fillvalue=fillvalue)

@deprecate imrotate(img::AbstractArray, θ::Real,       method::MethodType                     )  imrotate(img, θ;       method=method)
@deprecate imrotate(img::AbstractArray, θ::Real,                           fillvalue::FillType)  imrotate(img, θ;       fillvalue=fillvalue)
@deprecate imrotate(img::AbstractArray, θ::Real,       method::MethodType, fillvalue::FillType)  imrotate(img, θ; method=method, fillvalue=fillvalue)
@deprecate imrotate(img::AbstractArray, θ::Real,       fillvalue::FillType, method::MethodType)  imrotate(img, θ; method=method, fillvalue=fillvalue)
@deprecate imrotate(img::AbstractArray, θ::Real, inds, method::MethodType                     )  imrotate(img, θ, inds; method=method)
@deprecate imrotate(img::AbstractArray, θ::Real, inds,                     fillvalue::FillType)  imrotate(img, θ, inds; fillvalue=fillvalue)
@deprecate imrotate(img::AbstractArray, θ::Real, inds, method::MethodType, fillvalue::FillType)  imrotate(img, θ, inds; method=method, fillvalue=fillvalue)
@deprecate imrotate(img::AbstractArray, θ::Real, inds, fillvalue::FillType, method::MethodType)  imrotate(img, θ, inds; method=method, fillvalue=fillvalue)

@deprecate WarpedView(img::AbstractArray, tform::Transformation,       method::MethodType,                      ) WarpedView(img, tform; method=method)
@deprecate WarpedView(img::AbstractArray, tform::Transformation,                             fillvalue::FillType) WarpedView(img, tform; fillvalue=fillvalue)
@deprecate WarpedView(img::AbstractArray, tform::Transformation,       method::MethodType,   fillvalue::FillType) WarpedView(img, tform; method=method, fillvalue=fillvalue)
@deprecate WarpedView(img::AbstractArray, tform::Transformation,       fillvalue::FillType,   method::MethodType) WarpedView(img, tform; method=method, fillvalue=fillvalue)
@deprecate WarpedView(img::AbstractArray, tform::Transformation, inds, method::MethodType,                      ) WarpedView(img, tform, inds; method=method)
@deprecate WarpedView(img::AbstractArray, tform::Transformation, inds,                       fillvalue::FillType) WarpedView(img, tform, inds; fillvalue=fillvalue)
@deprecate WarpedView(img::AbstractArray, tform::Transformation, inds, method::MethodType,   fillvalue::FillType) WarpedView(img, tform, inds; method=method, fillvalue=fillvalue)
@deprecate WarpedView(img::AbstractArray, tform::Transformation, inds, fillvalue::FillType,   method::MethodType) WarpedView(img, tform, inds; method=method, fillvalue=fillvalue)

@deprecate warpedview(args...; kwargs...) WarpedView(args...; kwargs...)
@deprecate invwarpedview(args...; kwargs...) InvWarpedView(args...; kwargs...)

@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation,       method::MethodType,                      ) InvWarpedView(img, tinv; method=method)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation,                             fillvalue::FillType) InvWarpedView(img, tinv; fillvalue=fillvalue)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation,       method::MethodType,   fillvalue::FillType) InvWarpedView(img, tinv; method=method, fillvalue=fillvalue)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation,       fillvalue::FillType,   method::MethodType) InvWarpedView(img, tinv; method=method, fillvalue=fillvalue)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation, inds, method::MethodType,                      ) InvWarpedView(img, tinv, inds; method=method)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation, inds,                       fillvalue::FillType) InvWarpedView(img, tinv, inds; fillvalue=fillvalue)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation, inds, method::MethodType,   fillvalue::FillType) InvWarpedView(img, tinv, inds; method=method, fillvalue=fillvalue)
@deprecate InvWarpedView(img::AbstractArray, tinv::Transformation, inds, fillvalue::FillType,   method::MethodType) InvWarpedView(img, tinv, inds; method=method, fillvalue=fillvalue)

# END 0.9 deprecations

"""
    WarpedView(img, tform, [indices]; kwargs...) -> wv

Create a view of `img` that lazily transforms any given index `I`
passed to `wv[I]` so that `wv[I] == img[tform(I)]`.

This is the lazy view version of `warp`, please see [`warp`](@ref)
for more information.
"""
struct WarpedView{T,N,A<:AbstractArray,F<:Transformation,I<:Tuple,E<:AbstractExtrapolation} <: AbstractArray{T,N}
    parent::A
    transform::F
    indices::I
    extrapolation::E
end

function WarpedView(
        A::AbstractArray{T, N},
        tform::Transformation,
        inds=autorange(A, inv(tform)); kwargs...) where {T,N,}
    etp = box_extrapolation(A; kwargs...)
    WarpedView{T,N,typeof(A),typeof(tform),typeof(inds),typeof(etp)}(A, tform, inds, etp)
end

@inline Base.parent(A::WarpedView) = A.parent
@inline Base.axes(A::WarpedView) = A.indices
@inline Base.size(A::WarpedView) = map(length,axes(A))

Base.@propagate_inbounds function Base.getindex(A::WarpedView{T,N}, I::Vararg{Int,N}) where {T,N}
    convert(T, _getindex(A.extrapolation, A.transform(SVector(I))))
end

function Base.showarg(io::IO, A::WarpedView, toplevel)
    print(io, "WarpedView(")
    Base.showarg(io, parent(A), false)
    print(io, ", ")
    print(io, A.transform)
    if toplevel
        print(io, ") with eltype ", eltype(parent(A)))
    else
        print(io, ')')
    end
end

using Documenter, DemoCards
using Documenter.Remotes: GitHub
using ImageBase, ImageTransformations, ImageShow
using TestImages
using CoordinateTransformations, Interpolations, Rotations

# this is used to trigger artifact download and IO backend precompilation
testimage.(["cameraman", "lighthouse"])

examples, postprocess_cb, examples_assets = makedemos("examples")
format = Documenter.HTML(edit_link = "master",
                         prettyurls = get(ENV, "CI", nothing) == "true",
                         assets = [examples_assets,], size_threshold = nothing)

makedocs(modules  = [ImageTransformations, ImageBase],
         repo     = GitHub("JuliaImages/ImageTransformations.jl"),
         format   = format,
         sitename = "ImageTransformations",
         pages    = [
             "index.md",
             examples,
             "reference.md"],
         warnonly = [:missing_docs])

postprocess_cb()

deploydocs(repo   = "github.com/JuliaImages/ImageTransformations.jl.git")

"""
    autorange(A::AbstractArray, tform::Transformation)

For given transformation `tform`, return the "smallest" range indices that
preserves all information from `A` after applying `tform`.

# Examples

For transformation that preserves the array size, `autorange` is equivalent to `axes(A)`.

```jldoctest; setup=:(using ImageTransformations: autorange; using CoordinateTransformations, Rotations, ImageTransformations)
julia> A = rand(5, 5);

julia> tform = IdentityTransformation();

julia> autorange(A, tform) == axes(A)
true
```

The diffrence shows up when `tform` enlarges the input array `A`. In the following example, we need
at least `(0:6, 0:6)` as the range indices to get all data of `A`:

```jldoctest; setup=:(using ImageTransformations: autorange; using CoordinateTransformations, Rotations, ImageTransformations)
julia> A = rand(5, 5);

julia> tform = recenter(RotMatrix(pi/8), center(A));

julia> autorange(A, tform)
(0:6, 0:6)
```

!!! note
    This function is not exported; it is mainly for internal usage to infer the default indices.
"""
autorange(A::AbstractArray, tform) = autorange(CartesianIndices(A), tform)
function autorange(R::CartesianIndices, tform)
    mn = mx = tform(SVector(first(R).I))
    for I in CornerIterator(R)
        x = tform(SVector(I.I))
        # we map min and max to prevent type-inference issues
        # (because min(::SVector,::SVector) -> Vector)
        mn = map(min, x, mn)
        mx = map(max, x, mx)
    end
    _autorange(Tuple(mn), Tuple(mx))
end

@noinline _autorange(mn,mx) = map((a,b)->floor(Int,_round(a)):ceil(Int,_round(b)), mn, mx)

## Iterate over the corner-indices of a rectangular region
struct CornerIterator{I<:CartesianIndex}
    start::I
    stop::I
end
CornerIterator(R::CartesianIndices) = CornerIterator(first(R), last(R))

Base.eltype(::Type{CornerIterator{I}}) where {I} = I
Base.Iterators.IteratorSize(::Type{CornerIterator{I}}) where {I<:CartesianIndex{N}} where {N} = Base.Iterators.HasShape{N}()

# in 0.6 we could write: 1 .+ (iter.stop.I .- iter.start.I .!= 0)
Base.size(iter::CornerIterator{CartesianIndex{N}}) where {N} = ntuple(d->iter.stop.I[d]-iter.start.I[d]==0 ? 1 : 2, Val(N))::NTuple{N,Int}
Base.length(iter::CornerIterator) = prod(size(iter))

@inline function Base.iterate(iter::CornerIterator{<:CartesianIndex})
    if any(map(>, iter.start.I, iter.stop.I))
        return nothing
    end
    iterate(iter, iter.start)
end

@inline function Base.iterate(iter::CornerIterator{I}, state) where I<:CartesianIndex
    if state.I[end] > iter.stop.I[end]
        return nothing
    end
    state, I(inc(state.I, iter.start.I, iter.stop.I))
end

# increment & carry
@inline inc(::Tuple{}, ::Tuple{}, ::Tuple{}) = ()
# the max(1, ...) makes sure that the code doesn't break
# for corner cases where if stop == start
# (e.g. CornerIterator(CartesianRange((1,1))))
@inline inc(state::Tuple{Int}, start::Tuple{Int}, stop::Tuple{Int}) = (state[1]+(max(1,stop[1]-start[1])),)
@inline function inc(state, start, stop)
    if state[1] < stop[1]
        return (stop[1],tail(state)...)
    end
    newtail = inc(tail(state), tail(start), tail(stop))
    (start[1], newtail...)
end

# 0-d is special-cased to iterate once and only once
Base.iterate(iter::CornerIterator{<:CartesianIndex{0}}) = (iter.start, nothing)
Base.iterate(iter::CornerIterator{<:CartesianIndex{0}}, state) = nothing

# Ensure that we use StaticArrays for linear transformations
try_static(tfm, img) = tfm   # fallback
try_static(tfm::AffineMap{<:SMatrix, <:SVector}, img::AbstractArray{T,N}) where {T,N} = tfm
try_static(tfm::AffineMap{<:AbstractMatrix, <:AbstractVector}, img::AbstractArray{T,N}) where {T,N} =
    AffineMap(SMatrix{N,N}(tfm.linear), SVector{N}(tfm.translation))
try_static(tfm::LinearMap{<:SMatrix}, img::AbstractArray{T,N}) where {T,N} = tfm
try_static(tfm::LinearMap{<:AbstractMatrix}, img::AbstractArray{T,N}) where {T,N} =
    LinearMap(SMatrix{N,N}(tfm.linear))
try_static(tfm::Translation{<:SVector}, img::AbstractArray{T,N}) where {T,N} = tfm
try_static(tfm::Translation{<:AbstractVector}, img::AbstractArray{T,N}) where {T,N} =
    Translation(SVector{N}(tfm.translation))

# Slightly round/discretize the output coordinates so that the warped image size isn't affected by
# numerical stability
# https://github.com/JuliaImages/ImageTransformations.jl/issues/104
_default_digits(::Type{T}) where T<:Number = _default_digits(floattype(T))
# these constants come from eps() digits
_default_digits(::Type{T}) where T<:AbstractFloat = ceil(Int, -log10(sqrt(eps(T))))
_default_digits(::Type{Float64}) = 8
_default_digits(::Type{Float32}) = 4

_round(x::T; digits=_default_digits(T), kwargs...) where T<:Number = round(x; digits=digits, kwargs...)

@testset "restrict" begin
    img = repeat(range(0, stop=1, length=100), 1, 100)
    tfm = recenter(RotMatrix(pi/8), center(img))

    for wv in [
        WarpedView(img, tfm),
        InvWarpedView(img, tfm)
    ]
        out = restrict(wv)
        ref = restrict(OffsetArray(collect(wv), axes(wv)))
        @test nearlysame(out, ref)
        @test out isa OffsetArray

        for dims in [1, (2, )]
            out = restrict(wv, dims)
            ref = restrict(OffsetArray(collect(wv), axes(wv)), dims)
            @test nearlysame(out, ref)
            @test out isa OffsetArray
        end
    end
end

macro maybe_test_broken(args...)
    if VERSION < v"1.10.0-DEV.0"
        return quote
            @test_broken $(esc(args...))
        end
    else
        return quote
            $(esc(args...))
        end
    end
end

@testset "Image resize" begin
    testcolor = (RGB,Gray)
    testtype = (Float32, Float64, N0f8, N0f16)

    @testset "Interface" begin
        function test_imresize_interface_core(img, outsz, args...; kargs...)
            img2 = @test_nowarn imresize(img, args...; kargs...)
            @test size(img2) == outsz
            @test eltype(img2) == eltype(img)
        end
        function test_imresize_interface(img, outsz, args...; kargs...)
            @maybe_test_broken @inferred imresize(img, args...; kargs...) # FIXME: @inferred failed
            test_imresize_interface_core(img, outsz, args...; kargs...)
        end
        function test_imresize_interface_broken(img, outsz, args...; kargs...)
            @test_broken @inferred imresize(img, args...; kargs...) # FIXME: @inferred failed
            test_imresize_interface_core(img, outsz, args...; kargs...)
        end
        for C in testcolor, T in testtype
            img = rand(C{T},10,10)

            test_imresize_interface(img, (5,5), (5,5))
            test_imresize_interface_broken(img, (5,5), (1:5,1:5)) # FIXME: @inferred failed
            test_imresize_interface(img, (5,5), 5,5)
            test_imresize_interface_broken(img, (5,5), 1:5,1:5) # FIXME: @inferred failed
            test_imresize_interface(img, (5,5), ratio = 0.5)
            test_imresize_interface(img, (20,20), ratio = 2)
            test_imresize_interface(img, (20,20), ratio = (2, 2))
            test_imresize_interface(img, (20,10), ratio = (2, 1))
            test_imresize_interface(img, (10,10), ())
            test_imresize_interface(img, (5,10), 5)
            test_imresize_interface(img, (5,10), (5,))
            test_imresize_interface_broken(img, (5,10), 1:5) # FIXME: @inferred failed
            test_imresize_interface_broken(img, (5,10), (1:5,)) # FIXME: @inferred failed

            @test_throws MethodError imresize(img,5.0,5.0)
            @test_throws MethodError imresize(img,(5.0,5.0))
            @test_throws MethodError imresize(img,(5, 5.0))
            @test_throws MethodError imresize(img,[5,5])
            @test_throws UndefKeywordError imresize(img)
            @test_throws DimensionMismatch imresize(img,(5,5,5))
            @test_throws ArgumentError imresize(img, ratio = -0.5)
            @test_throws ArgumentError imresize(img, ratio = (-0.5, 1))
            @test_throws DimensionMismatch imresize(img, ratio=(5,5,5))
            @test_throws DimensionMismatch imresize(img, (5,5,1))
        end
    end

    @testset "Numerical" begin
        # RGB is skipped
        for C in (Gray,), T in testtype
            A = [1 0; 0 1] .|> C{T}
            @test imresize(A, (1, 1)) ≈ reshape([0.5], 1, 1) .|> C{T}
            # if only 1 of 4 pixels is nonzero, check that you get 1/4 the
            # value (no matter where it is)
            for i = 1:4
                fill!(A, 0)
                A[i] = 1
                A = C{T}.(A)
                @test imresize(A, (1, 1)) ≈ reshape([0.25], 1, 1) .|> C{T}
            end
            A = [1 0; 0 0] .|> C{T}
            @test imresize(A, (2, 1)) ≈ reshape([0.5, 0], (2, 1)) .|> C{T}
            @test imresize(A, (1, 2)) ≈ reshape([0.5, 0], (1, 2)) .|> C{T}
            A = [1 0 0; 0 0 0; 0 0 0] .|> C{T}
            @test imresize(A, (2, 2)) ≈ [0.75^2 0; 0 0] .|> C{T}

            A = ones(5,5) .|> C{T}
            for l2 = 3:7, l1 = 3:7
                R = imresize(A, (l1, l2))
                @test all(x->x==1, R)
            end
            for l2 = 3:7, l1 = 3:7
                R = imresize(A, (0:l1-1, 0:l2-1))
                @test all(x->x==1, R)
                @test axes(R) == (0:l1-1, 0:l2-1)
            end
            for l1 = 3:7
                R = imresize(A, (0:l1-1,))
                @test all(x->x==1, R)
                @test axes(R) == (0:l1-1, 1:5)
            end

            R = imresize(A, (2:6, 0:4))
            @test all(x->x==1, R)
            @test axes(R) == (2:6, 0:4)
            R = imresize(A, ())
            @test all(x->x==1, R)
            @test axes(R) == axes(A)
            @test !(R === A)
            Ao = OffsetArray(A, -2:2, 0:4)
            R = imresize(Ao, (5,5))
            @test axes(R) === axes(A)
            R = imresize(Ao, axes(Ao))
            @test axes(R) === axes(Ao)
            @test !(R === A)
            img = reshape([0.5])
            R = imresize(img, ())
            @test ndims(R) == 0
            @test !(R === A)
        end

    @testset "Interpolation" begin
        img = rand(16,16)
        out = imresize(img, (128,128), method=Lanczos4OpenCV())
        @test size(out) == (128,128)

        out = imresize(img, (128,128), method=Linear())
        @test size(out) == (128,128)

        out = imresize(img, (16,16), method=Lanczos4OpenCV())
        @test size(out) == (16,16)

        #test default behavior
        @test imresize(img, (128,128)) == imresize(img, (128,128), method=Linear())

        # test that out-of-place and in-place produce the same result.
        resized = zeros(eltype(img), 128, 128)
        @test imresize(img, (128, 128)) == imresize!(resized, img)
        @test imresize(img, (128, 128), method=Linear()) == imresize!(resized, img, method=Linear())
        @test imresize(img, (128, 128), method=BSpline(Linear())) == imresize!(resized, img, method=BSpline(Linear()))
        @test imresize(img, (128, 128), method=Lanczos4OpenCV()) == imresize!(resized, img, method=Lanczos4OpenCV())

        #check error handling
        @test_throws ArgumentError imresize(img, BSpline(Linear()))
        @test_throws ArgumentError imresize(img, Linear())

        #consisency checks
        @test imresize(img, (128, 128), method=Linear()) == imresize(OffsetArray(img, -1, -1), (128, 128), method=Linear())
        @test imresize(img, (128, 128), method=BSpline(Linear())) == imresize(OffsetArray(img, -1, -1), (128, 128), method=BSpline(Linear()))
        @test imresize(img, (128, 128), method=Lanczos4OpenCV()) == imresize(OffsetArray(img, -1, -1), (128, 128), method=Lanczos4OpenCV())

        out = imresize(img, (0:127, 0:127), method=Linear())
        @test axes(out) == (0:127, 0:127)
        @test OffsetArrays.no_offset_view(out) == imresize(img, (128, 128), method=Linear())

        out = imresize(img, (0:127, 0:127), method=BSpline(Linear()))
        @test axes(out) == (0:127, 0:127)
        @test OffsetArrays.no_offset_view(out) == imresize(img, (128, 128), method=BSpline(Linear()))

        out = imresize(img, (0:127, 0:127), method=Lanczos4OpenCV())
        @test axes(out) == (0:127, 0:127)
        @test OffsetArrays.no_offset_view(out) == imresize(img, (128, 128), method=Lanczos4OpenCV())
        end
    end

    @testset "special RGB/Gray types (#97)" begin
        ori = repeat(distinguishable_colors(10), inner=(1, 10))
        for T in (
            RGB, BGR, RGBX, XRGB,
            ARGB, RGBA,
            RGB24, ARGB32,
        )
            img = T.(ori)
            out = @inferred imresize(img, ratio=2)
            @test eltype(out) <: T
            ref = imresize(ori, ratio=2)
            @test ref ≈ RGB.(out)
        end
        for T in (Gray, AGray, GrayA, Gray24)
            img = T.(ori)
            out = @inferred imresize(img, ratio=2)
            @test eltype(out) <: T
            ref = imresize(Gray.(ori), ratio=2)
            @test ref ≈ Gray.(out)
        end
    end

    @testset "In-place resizing should not modify original image" begin
        for c in testcolor
            image = rand(c, 128, 128)
            original = copy(image)
            out = zeros(eltype(image), 32, 32)

            methods = (
                Constant(), Linear(),
                Quadratic(Reflect(OnCell())),
                Quadratic(InPlace(OnCell())),
                Cubic(Line(OnGrid())), Lanczos4OpenCV())
            for method in methods
                imresize!(out, image, method=method)
                @test image == original
            end
        end
    end
end

# restrict
function restrict(img::Union{WarpedView, InvWarpedView}, dims::Integer)
    # preserve axes information but eagerly evaluate the transformation
    # TODO: this eager evaluation destroy the laziness of `WarpedView`
    #       and `InvWarpedView`.
    restrict(OffsetArray(collect(img), axes(img)), dims)
end

# imresize
imresize(original::AbstractArray, dim1::T, dimN::T...; kwargs...) where T<:Union{Integer,AbstractUnitRange} = imresize(original, (dim1,dimN...); kwargs...)
function imresize(original::AbstractArray; ratio, kwargs...)
    all(ratio .> 0) || throw(ArgumentError("ratio $ratio should be positive"))
    new_size = ceil.(Int, size(original) .* ratio) # use ceil to avoid 0
    imresize(original, new_size; kwargs...)
end

function imresize(original::AbstractArray, short_size::Union{Indices{M},Dims{M}}; kwargs...) where M
    len_short = length(short_size)
    len_short > ndims(original) && throw(DimensionMismatch("$short_size has too many dimensions for a $(ndims(original))-dimensional array"))
    new_size = ntuple(i -> (i > len_short ? odims(original, i, short_size) : short_size[i]), ndims(original))
    imresize(original, new_size; kwargs...)
end

function imresize(original::AbstractArray, itp::Union{Interpolations.Degree,Interpolations.InterpolationType}, args...; kwargs...)
    throw(ArgumentError("Positional parameter for interpolation method is not supported; use keyword `method` instead."))
end

odims(original, i, short_size::Tuple{Integer,Vararg{Integer}}) = size(original, i)
odims(original, i, short_size::Tuple{}) = axes(original, i)
odims(original, i, short_size) = oftype(first(short_size), axes(original, i))

"""
    imresize(img, sz; [method]) -> imgr
    imresize(img, inds; [method]) -> imgr
    imresize(img; ratio, [method]) -> imgr

upsample/downsample the image `img` to a given size `sz` or axes `inds` using interpolations. If
`ratio` is provided, the output size is then `ceil(Int, size(img).*ratio)`.

!!! tip
    This interpolates the values at sub-pixel locations. If you are shrinking the image, you risk
    aliasing unless you low-pass filter `img` first.

# Arguments

- `img`: the input image array
- `sz`: the size of output array
- `inds`: the axes of output array
  If `inds` is passed, the output array `imgr` will be `OffsetArray`.

# Parameters

!!! info
    To construct `method`, you may need to load `Interpolations` package first.

- `ratio`: the upsample/downsample ratio used.
  The output size is `ceil.(Int, size(img).*ratio)`. If `ratio` is larger than `1`, it is
  an upsample operation. Otherwise it is a downsample operation. `ratio` can also be a tuple,
  in which case `ratio[i]` specifies the resize ratio at dimension `i`.
- `method::InterpolationType`: 
  specify the interpolation method used for reconstruction. conveniently, `methold` can
  also be a `Degree` type, in which case a `BSpline` object will be created.
  For example, `method = Linear()` is equivalent to `method = BSpline(Linear())`.

# Examples

```julia
using ImageTransformations, TestImages, Interpolations

img = testimage("lighthouse") # 512*768

# pass integers as size
imresize(img, 256, 384) # 256*384
imresize(img, (256, 384)) # 256*384
imresize(img, 256) # 256*768

# pass indices as axes
imresize(img, 1:256, 1:384) # 256*384
imresize(img, (1:256, 1:384)) # 256*384
imresize(img, (1:256, )) # 256*768

# pass resize ratio
imresize(img, ratio = 0.5) #256*384
imresize(img, ratio = (2, 1)) # 1024*768

# use different interpolation method
imresize(img, (256, 384), method=Linear()) # 256*384 bilinear interpolation
imresize(img, (256, 384), method=Lanczos4OpenCV()) # 256*384 OpenCV-compatible Lanczos 4 interpolation
```

For downsample with `ratio=0.5`, [`restrict`](@ref) is a much faster two-fold implementation that
you can use.
"""
function imresize(original::AbstractArray{T,0}, new_inds::Tuple{}; kwargs...) where T
    Tnew = imresize_type(first(original))
    copyto!(similar(original, Tnew), original)
end

function imresize(original::AbstractArray{T,N}, new_size::Dims{N}; kwargs...) where {T,N}
    Tnew = imresize_type(first(original))
    inds = axes(original)
    if map(length, inds) == new_size
        dest = similar(original, Tnew, new_size)
        if axes(dest) == inds
            copyto!(dest, original)
        else
            copyto!(dest, CartesianIndices(axes(dest)), original, CartesianIndices(inds))
        end
    else
        imresize!(similar(original, Tnew, new_size), original; kwargs...)
    end
end

function imresize(original::AbstractArray{T,N}, new_inds::Indices{N}; kwargs...) where {T,N}
    Tnew = imresize_type(first(original))
    if axes(original) == new_inds
        copyto!(similar(original, Tnew), original)
    else
        imresize!(similar(original, Tnew, new_inds), original; kwargs...)
    end
end

# To choose the output type, rather than forcing everything to
# Float64 by multiplying by 1.0, we exploit the fact that the scale
# changes correspond to integer ratios.  We mimic ratio arithmetic
# without actually using Rational (which risks promoting to a
# Rational type, too slow for image processing).
function imresize_type(c::Colorant)
    CT = base_colorant_type(c)
    isconcretetype(CT) && return CT # special 0-parameter colorant types: ARGB32, etc
    CT{eltype(imresize_type(Gray(c)))}
end
imresize_type(c::Gray) = Gray{imresize_type(gray(c))}
imresize_type(c::FixedPoint) = typeof(c)
imresize_type(c) = typeof((c*1)/1)

function imresize!(resized::AbstractArray{T,N}, original::AbstractArray{S,N}; method::Union{Interpolations.Degree,Interpolations.InterpolationType}=BSpline(Linear()), kwargs...) where {T,S,N}
    _imresize!(resized, original, method; kwargs...)
end
@inline function _imresize!(resized, original, method::Union{D, Interpolations.BSpline{D}}; kwargs...) where D <: Union{Constant, Linear}
    imresize!(resized, interpolate!(original, wrap_BSpline(method)))
end
@inline function _imresize!(resized, original, method; kwargs...)
    imresize!(resized, interpolate(original, wrap_BSpline(method)))
end

function imresize!(resized::AbstractArray{T,N}, original::AbstractInterpolation{S,N}) where {T,S,N}
    # Define the equivalent of an affine transformation for mapping
    # locations in `resized` to the corresponding position in
    # `original`. We take the viewpoint that a pixel at `i, j` is a
    # sensor that *integrates* the intensity over an area spanning
    # `i±0.5, j±0.5` (this is a good model of how a camera pixel
    # actually works). We then map the *outer corners* of the two
    # images to each other, i.e., in typical cases
    #     (0.5, 0.5) -> (0.5, 0.5)  (outer corner, top left)
    #     size(resized)+0.5 -> size(original)+0.5  (outer corner, lower right)
    # This ensures that both images cover exactly the same area.
    Ro, Rr = CartesianIndices(axes(original)), CartesianIndices(axes(resized))
    sf = map(/, (last(Ro)-first(Ro)).I .+ 1, (last(Rr)-first(Rr)).I .+ 1) # +1 for outer corners
    offset = map((io,ir,s)->io - 0.5 - s*(ir-0.5), first(Ro).I, first(Rr).I, sf)
    if all(x->x >= 1, sf)
        @inbounds for I in Rr
            I_o = map3((i,s,off)->s*i+off, I.I, sf, offset)
            resized[I] = original(I_o...)
        end
    else
        @inbounds for I in Rr
            I_o = clampR(map3((i,s,off)->s*i+off, I.I, sf, offset), Ro)
            resized[I] = original(I_o...)
        end
    end
    resized
end

# map isn't optimized for 3 tuple-arguments, so do it here
@inline map3(f, a, b, c) = (f(a[1], b[1], c[1]), map3(f, tail(a), tail(b), tail(c))...)
@inline map3(f, ::Tuple{}, ::Tuple{}, ::Tuple{}) = ()

function clampR(I::NTuple{N}, R::CartesianIndices{N}) where N
    map3(clamp, I, first(R).I, last(R).I)
end

"""
    InvWarpedView(img, tinv, [indices]; kwargs...) -> wv
    InvWarpedView(inner_view, tinv) -> wv

Create a view of `img` that lazily transforms any given index `I`
passed to `wv[I]` so that `wv[I] == img[inv(tinv)(I)]`.

Except for the lazy evaluation, the following two lines are expected to be equivalent:

```julia
warp(img, inv(tform), [indices]; kwargs...)
invwarpedview(img, tform, [indices]; kwargs...)
```

The conceptual difference to [`WarpedView`](@ref) is that
`InvWarpedView` is intended to be used when reasoning about the
image is more convenient that reasoning about the indices.
Furthermore, `InvWarpedView` allows simple nesting of
transformations, in which case the transformations will be
composed into a single one.

For detailed explaination of warp, associated arguments and parameters,
please refer to [`warp`](@ref).
"""
struct InvWarpedView{T,N,A,F,I,FI<:Transformation,E} <: AbstractArray{T,N}
    inner::WarpedView{T,N,A,F,I,E}
    inverse::FI
end

function InvWarpedView(inner::WarpedView{T,N,TA,F,I,E}) where {T,N,TA,F,I,E}
    tinv = inv(inner.transform)
    InvWarpedView{T,N,TA,F,I,typeof(tinv),E}(inner, tinv)
end

function InvWarpedView(A::AbstractArray, tinv::Transformation, inds::Tuple = autorange(A, tinv); kwargs...)
    inner = WarpedView(A, inv(tinv), inds; kwargs...)
    InvWarpedView(inner, tinv)
end

function InvWarpedView(inner::InvWarpedView, outer_tinv::Transformation)
    tinv = compose(outer_tinv, inner.inverse)
    InvWarpedView(parent(inner), tinv)
end

function InvWarpedView(inner::InvWarpedView, outer_tinv::Transformation, inds::Tuple)
    tinv = compose(outer_tinv, inner.inverse)
    InvWarpedView(parent(inner), tinv, inds)
end

@inline Base.parent(A::InvWarpedView) = parent(A.inner)
@inline Base.axes(A::InvWarpedView) = axes(A.inner)
@inline Base.size(A::InvWarpedView) = size(A.inner)

Base.@propagate_inbounds Base.getindex(A::InvWarpedView{T,N}, I::Vararg{Int,N}) where {T,N} = A.inner[I...]

function Base.showarg(io::IO, A::InvWarpedView, toplevel)
    print(io, "InvWarpedView(")
    Base.showarg(io, parent(A), false)
    print(io, ", ")
    print(io, A.inverse)
    if toplevel
        print(io, ") with eltype ", eltype(parent(A)))
    else
        print(io, ')')
    end
end

"""

This package provides support for image resizing, image rotation, and other spatial transformations of arrays.

- `WarpedView`: Create a view of `img` that lazily transforms any given index `I` passed to `wv[I]` so that `wv[I] == img[tform(I)]`.
- `warp`: An eager evaluation variant of `WarpedView`. Transform the coordinates of `img`, returning a new `imgw` satisfying `imgw[I] = img[tform(I)]`.
- `InvWarpedView`: Create a view of `img` that lazily transforms any given index `I` passed to `wv[I]` so that `wv[I] == img[inv(tinv)(I)]`.
- `imresize`: Upsample/downsample the image `img` to a given size `sz` or axes `inds` using interpolations.
- `restrict`: A much more efficient version of `imresize` that two-folds/down-samples image to approximate 1/2 size. (This is now provided by `ImageBase.restrict`)
- `imrotate`: Rotate image `img` by `θ`∈[0,2π) in a clockwise direction around its center point.
- `autorange`: For given transformation `tform`, return the "smallest" range indices that preserves all information from `A` after applying `tform`.

There are in-place version of many of the functions, e.g., `imresize!` etc.

Resize example:

```julia
using ImageTransformations, TestImages

img = testimage("mandrill")

img_small = imresize(img, ratio=1/8)
img_medium = imresize(img_small, size(img_small).*2)
```

Warping example:

```julia
using ImageTransformations, TestImages, CoordinateTransformations, Rotations

img = testimage("camera");

# define transformation
trfm = recenter(RotMatrix(pi/8), center(img));
imgw = warp(img, trfm);
```
"""
module ImageTransformations

using ImageCore
using CoordinateTransformations
using Rotations
using StaticArrays
using Interpolations, AxisAlgorithms
using OffsetArrays

using Base: tail, Indices

# these two symbols previously live in ImageTransformations
import ImageBase: restrict, restrict!

export

    restrict,
    imresize,
    imresize!,
    center,
    warp,
    WarpedView,
    warpedview,
    InvWarpedView,
    invwarpedview,
    imrotate

include("autorange.jl")
include("interpolations.jl")
include("warp.jl")
include("warpedview.jl")
include("invwarpedview.jl")
include("resizing.jl")
include("compat.jl")
include("deprecated.jl")

# TODO: move to warp.jl
@inline _getindex(A, v::StaticVector) = A[Tuple(v)...]
@inline _getindex(A::AbstractInterpolation, v::StaticVector) = A(Tuple(v)...)
@inline _getindex(A, v) = A[v...]
@inline _getindex(A::AbstractInterpolation, v) = A(v...)

center(img::AbstractArray{T,N}) where {T,N} = SVector{N}(map(_center, axes(img)))
_center(ind::AbstractUnitRange) = (first(ind)+last(ind))/2

end # module

struct TwoInts
    dim1::Int
    dim2::Int
end

Base.length(::TwoInts) = 2
Base.iterate(ti::TwoInts) = ti.dim1, false
function Base.iterate(ti::TwoInts, isdone::Bool)
    isdone && return nothing
    return ti.dim2, true
end

Base.:(-)(ti::TwoInts) = TwoInts(-ti.dim1, -ti.dim2)
Base.:(+)(v::SVector{2}, ti::TwoInts) = TwoInts(v[1] + ti.dim1, v[2] + ti.dim2)

# [Package References](@id package_references)


# High-level API

```@docs
ImageBase.restrict
ImageTransformations.imrotate
ImageTransformations.imresize
```

# Low-level warping API

```@docs
ImageTransformations.warp
ImageTransformations.WarpedView
ImageTransformations.InvWarpedView
```

# Utilities

```@docs
ImageTransformations.autorange
```

# ImageTransformations.jl

```@setup overview
using ImageShow
```

This package provides support for image resizing, image rotation, and
other spatial transformations of arrays.

## Overview

ImageTransformations.jl consists of two sets of API: the low level warping operations, and the high-level operations that built on top of it.

- Low-level warping API:
  - `warp`: backward-mode warping
  - `WarpedView`: the lazy view version of `warp`
  - `InvWarpedView`: the inverse of `WarpedView`
- high-level spatial operations:
  - `imresize`: aspect adjustment
  - `restrict`: a much more efficient version of `imresize` that two-folds/down-samples image to approximate 1/2 size. (This is now provided by ImageBase.)
  - `imrotate`: rotation

For detailed usage of these functions, please refer to [function references](@ref package_references) and [examples](@ref Examples). The following section explains
the core concept image warping so that you can get a clear understanding about
this package while using it.

## [Image warping](@id index_image_warping)

!!! info
    This is just a very simple explaination on the internal of ImageTransformations. For more information about image warping, you can take a look at [the Princeton Computer Graphics course for Image Warping (Fall 2000)](https://www.cs.princeton.edu/courses/archive/fall00/cs426/lectures/warp/warp.pdf)

Most image spatial transformation operations (e.g., rotation, resizing, translation) fall into the category of warping operation. Mathematically, for given input image `X`, a (backward-mode) warping operation `f` consists of two functions: coordination map `ϕ` and intensity estimator `τ`.

```math
Y_{i,j} = f(X)_{i, j} = τ(X, ϕ(i, j))
```

Take the following resizing operation as an example, for every pixel position `p` in output image `Y`, we 1) use the backward coordinate map `ϕ` to get its corresponding pixel position `q` in original image `X`. Since `q` may not be on grid, we need to 2) estimate the value of `X` on position `q` using function `τ`, and finally 3) assign `X[q]` back to `Y[p]`. In Julia words, it is

```julia
for p in CartesianIndices(Y)
    q = ϕ(p) # backward coordinate map
    v = τ(X, q) # estimate the value
    Y[p] = v # assign value back
end
```

As you may have notice, we use backward coordinate map because this is the simplest way to iterate every pixel of the output image. This is why it is called backward-mode warping. In some literature, it is also called reverse warping.

![warp resize demo](assets/warp_resize.png)

In ImageTransformations, the `warp`-based operation uses Interpolations as our intensity estimator `τ`:

```@example overview
using Interpolations, ImageCore, TestImages
using ImageTransformations

X = imresize(testimage("cameraman"), (64, 64)) # use small image as an example

sz = (128, 128)
Y = similar(X, sz...)

# intensity estimator using interpolation
itp = interpolate(X, BSpline(Linear())) # bilinear interpolation
τ(q) = itp(q...)

# A linear coordinate map that satisfies:
#   - `ϕ(1, 1) == (1, 1)`
#   - `ϕ(128, 128) == (64, 64)`
K = (size(X) .- (1, 1))./(sz .- (1, 1))
b = (1, 1) .- K
ϕ(p) = @. K*p + b

for p in CartesianIndices(Y)
    q = ϕ(p.I)
    Y[p] = τ(q)
end

mosaic(X, Y; nrow=1)
```

This is the internal of ImageTransformations. For common usage of ImageTransformations, you should use either the low-level API `warp` or
high-level API `imresize` and others.
